/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N log N)
 */

#include <stdio.h>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;

#define NMAX 200010
#define LL long long

#define MP make_pair
#define ff first
#define ss second

int N, M;

set <pair<int ,int> > H;

int xc[NMAX], yc[NMAX], rc[NMAX];
int xp[NMAX], yp[NMAX];

int nev = 0;
pair <pair<int, int>, int> ev[NMAX * 3];

int rez[NMAX];

int verif(int p, int c)
{
	LL dst = (LL) (xc[c] - xp[p]) * (xc[c] - xp[p]) + (LL) (yc[c] - yp[p]) * (yc[c] - yp[p]);

	return dst <= (LL) rc[c] * rc[c];
}

int main()
{
	int i;

	freopen("nuke.in", "r", stdin);
	freopen("nuke.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++) {
		scanf("%d %d", &xp[i], &yp[i]);
		ev[++nev] = MP(MP(xp[i], 0), i);
	}

	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &xc[i], &yc[i], &rc[i]);
		ev[++nev] = MP(MP(xc[i] - rc[i], -1), i);
		ev[++nev] = MP(MP(xc[i] + rc[i], 1), i);
	}


	sort(ev + 1, ev + nev + 1);

	for (i = 1; i <= nev; i++) {
		if (ev[i].ff.ss == -1) { // a intrat un cerc
			H.insert(MP(yc[ ev[i].ss ], ev[i].ss));
		}
		if (ev[i].ff.ss == 1) { // a iesit un cerc
			H.erase(MP(yc[ ev[i].ss ], ev[i].ss));
		}

		if (ev[i].ff.ss == 0) { // trebuie sa vad pentru punctu curent
			// hai cu lower_bound
			set <pair<int, int> > :: iterator it = H.lower_bound( MP(yp[ev[i].ss], 0) );


			if (it != H.end() && verif(ev[i].ss, it->ss)) rez[it->ss]++;
			if (it != H.begin()) {
				--it;
				if (verif(ev[i].ss, it->ss)) rez[it->ss]++;
			}
		}
	}

	for (i = 1; i <= M; i++) printf("%d\n", rez[i]);

	return 0;
}

