/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N^2) optimized
 */

#include <stdio.h>
#include <assert.h>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;

#define NMAX 200010
#define LL long long

#define MP make_pair
#define ff first
#define ss second

int N, M;

int ncd = 0;
int cd[NMAX];
int poz[NMAX];

int xc[NMAX], yc[NMAX], rc[NMAX];
int xp[NMAX], yp[NMAX];

int nev = 0;
pair <pair<int, int>, int> ev[NMAX * 3];

int rez[NMAX];

int verif(int p, int c)
{
	LL dst = (LL) (xc[c] - xp[p]) * (xc[c] - xp[p]) + (LL) (yc[c] - yp[p]) * (yc[c] - yp[p]);

	return dst <= (LL) rc[c] * rc[c];
}

char s[100]; int beg;

int GET(char s[], int &beg)
{
	int x = 0;

	for (; s[beg] && !(('0' <= s[beg] && s[beg] <= '9') || s[beg] == '-'); beg++);
//	for (; s[beg] && s[beg] == ' '; beg++);

	int smn = 1;
	if (s[beg] == '-') smn = -1, beg++;

	for (; '0' <= s[beg] && s[beg] <= '9'; beg++)
		x = x * 10 + s[beg] - '0';

	return x * smn;
}

int main()
{
	int i, mx = 0;

	freopen("nuke.in", "r", stdin);
	freopen("nuke.out", "w", stdout);

	scanf("%d %d\n", &N, &M);

	for (i = 1; i <= N; i++) {
		//scanf("%d %d", &xp[i], &yp[i]);
		fgets(s, 100, stdin); beg = 0;
		xp[i] = GET(s, beg);
		yp[i] = GET(s, beg);
		ev[++nev] = MP(MP(xp[i], 0), i);
	}

	for (i = 1; i <= M; i++) {
		//scanf("%d %d %d", &xc[i], &yc[i], &rc[i]);
		fgets(s, 100, stdin); beg = 0;
		xc[i] = GET(s, beg);
		yc[i] = GET(s, beg);
		rc[i] = GET(s, beg);
		ev[++nev] = MP(MP(xc[i] - rc[i], -1), i);
		ev[++nev] = MP(MP(xc[i] + rc[i], 1), i);
	}

	sort(ev + 1, ev + nev + 1);

	for (i = 1; i <= nev; i++) {
		if (ev[i].ff.ss == -1) { // a intrat un cerc
			cd[++ncd] = ev[i].ss;
			poz[ev[i].ss] = ncd;
			if (ncd > mx) mx = ncd;
		}
		if (ev[i].ff.ss == 1) { // a iesit un cerc
			int pc = poz[ev[i].ss];
			cd[pc] = cd[ncd];
			poz[cd[pc]] = pc;
			ncd--;
		}

		if (ev[i].ff.ss == 0) { // trebuie sa vad pentru punctu curent
			int q = 0;
			for (int j = 1; j <= ncd && !q; j++) rez[cd[j]] += verif(ev[i].ss, cd[j]);
		}
	}

	for (i = 1; i <= M; i++) printf("%d\n", rez[i]);
//	printf("%d\n", mx);

	system("./pcerc\n");

	return 0;
}

