/* 
 * Author: Tiberiu Savin
 * Complexity: M * N ^ 3
*/
#include <cstdio>
#include <algorithm>

using namespace std;

#define NMAX 52
#define MMAX 100
#define INF 0x3f3f3f3f

int N, M;
int P[NMAX][NMAX];
int A[MMAX][3];
int D[2][NMAX][NMAX][NMAX];

inline  void compute_mask(int l) {
	for (int i = 1; i <= N; i++) {
		for (int j = 1; j <= N; j++) {
			for (int k = 1; k <= N; k++) {
				int mask[3];
				int ind[] = {i, j, k};

				for (int S = 0; S < 8; S++) {
					for (int b = 0; b < 3; b++) {
						if ((1 << b) & S) {
							mask[b] = 0;
						} else {
							mask[b] = ind[b];
						}
					}

					int x = mask[0], y = mask[1], z = mask[2];
					D[l][x][y][z] = min(D[l][i][j][k], D[l][x][y][z]);
				}
			}
		}
	}
}

inline bool win(int l, int x, int y, int z) {
	int my_score = 0, his_score = 0;
	int pok[] = {x, y, z};
	for (int i = 0; i < 3; i++) {
		my_score += P[pok[i]][A[l][i]];
		his_score += P[A[l][i]][pok[i]];
	}

	return my_score > his_score;
}

int compute(int sx, int sy, int sz) {
	int ret;
	memset(D[0], INF, sizeof(D[0]));
	D[0][sx][sy][sz] = 0;

	compute_mask(0);
	int solx, soly, solz;
	for (int t = 1, l = 1; t <= M; t++, l = !l) {
//		printf("L = %d\n", l);
		memset(D[l], INF, sizeof(D[l]));
		ret = INF;
		for (int i = 1; i <= N; i++) {
			for (int j = 1; j <= N; j++) {
				for (int k = 1; k <= N; k++) {
					int ind[] = {i, j, k};
					int mask[3];
					int cst = 0;

					if (!win(t, i, j, k)) {
						D[l][i][j][k] = INF;
						continue;
					}

					for (int S = 0; S < 8; S++) {
						cst = 0;
						for (int b = 0; b < 3; b++) {
							if ((1 << b) & S) {
								mask[b] = 0;
								cst++;
							} else {
								mask[b] = ind[b];
							}
						}
						int x = mask[0], y = mask[1], z = mask[2];

						D[l][i][j][k] = min(D[l][i][j][k], D[!l][x][y][z] + cst);					
					}

//					printf("(%d %d %d) = %d\n", i, j, k, D[l][i][j][k]);
					if (ret > D[l][i][j][k]) {
						ret = D[l][i][j][k];
						solx = i;
						soly = j;
						solz = k;
					}
				}
			}
		}
		compute_mask(l);
	}

	//printf("%d %d %d\n", solx, soly, solz);
	return ret;
}


int main() {
	freopen("pokemon.in", "r", stdin);
	freopen("pokemon.out", "w", stdout);

	scanf("%d %d ", &N, &M);

	int sx, sy, sz;
	scanf("%d %d %d ", &sx, &sy, &sz);

	for (int i = 1; i <= N; i++) {
		for (int j = 1;  j <= N; j++) {
			scanf("%d ", &P[i][j]);
		}
	}

	for (int i = 1; i <= M; i++) {
		scanf("%d %d %d ", &A[i][0], &A[i][1], &A[i][2]);
	}

	int ret = compute(sx, sy, sz);
	printf("%d\n", ret);
	return 0;
}
