/* Author: Puni Andrei-Paul
 * Complexity: O(N^3 * M)
 * Method: Dinamic Programming
 * Implementation time: 30 min 
*/

#include <fstream>
#include <algorithm>

using namespace std;

#define Nmax 51
#define Mmax 101
#define Inf 0x3f3f3f3f

int best[2][Nmax][Nmax][Nmax];
int P = 0;
int a[Nmax][Nmax]; //1 daca pokemonul i il bate pe pokemonul j
int n,m; //nr de pokemoni , nr de pokemasteri
int P1, P2, P3; //pokemoni initiali

typedef struct { int p[3]; } pokemingi;
									
pokemingi inamic[Mmax];

//pt debug
//ofstream debug("log.txt");


void read() {
	ifstream fin("pokemon.in");
	
	fin >> n >> m;
	
	fin >> P1 >> P2 >> P3;
	
	for (int i = 1; i <= n; ++i)
	for (int j = 1; j <= n; ++j)
		fin >> a[i][j];
	
	for (int i = 1; i <= m; ++i)
		fin >> inamic[i].p[0] >> inamic[i].p[1] >> inamic[i].p[2];
	
	fin.close();
}

inline pokemingi makeBall(int p1, int p2, int p3) {
	pokemingi ret;
	ret.p[0] = p1;
	ret.p[1] = p2;
	ret.p[2] = p3;
	return ret;
}

inline bool bate(pokemingi A, pokemingi B) {
	int pct = 0;
	for (int i = 0; i < 3; ++i)
		pct += a[A.p[i]][B.p[i]] - a[B.p[i]][A.p[i]];					
	return pct > 0;
}

void solve() {	
	//initializez
	memset(best, 0x3f, sizeof best);
	best[1][P1][P2][P3] = 0;	
	best[1][0 ][P2][P3] = 0;	
	best[1][P1][0 ][P3] = 0;	
	best[1][0 ][0 ][P3] = 0;	
	best[1][P1][P2][0 ] = 0;	
	best[1][0 ][P2][0 ] = 0;	
	best[1][P1][0 ][0 ] = 0;	
	best[1][0 ][0 ][0 ] = 0;	

	for (int pokemaster = 1; pokemaster <= m; ++pokemaster, P ^= 1) { 			
		for (int p1 = 0; p1 <= n; ++p1)
			for (int p2 = 0; p2 <= n; ++p2) 
				for (int p3 = 0; p3 <= n; ++p3)
					best[P][p1][p2][p3] = Inf;

		for (int p1 = 1; p1 <= n; ++p1)
			for (int p2 = 1; p2 <= n; ++p2) 
				for (int p3 = 1; p3 <= n; ++p3) {
					#define check(x1,x2,x3,cost)															\
					if ( best[P][p1][p2][p3] > best[P^1][x1][x2][x3] + cost )	\
						best[P][p1][p2][p3] = best[P^1][x1][x2][x3] + cost; 

					//aici bat pe pokemaster si ajung la pasul curent
					if (bate(makeBall(p1,p2,p3), inamic[pokemaster])) {
						check(p1,p2,p3, 0)
						check(p1,p2,0 , 1)
						check(p1,0 ,p3, 1)
						check(p1,0 ,0 , 2)
						check(0 ,p2,p3, 1)
						check(0 ,p2,0 , 2)
						check(0 ,0 ,p3, 2)
						check(0 ,0 ,0 , 3)
					}
					
					#define up(x1,x2,x3)													\
					if (best[P][x1][x2][x3] > best[P][p1][p2][p3])		\
						best[P][x1][x2][x3] = best[P][p1][p2][p3];

					//aici fac update la starile cu *	din pasul curent
					up(p1,p2,0 )
					up(p1,0 ,p3)
					up(p1,0 ,0 )
					up(0 ,p2,p3)
					up(0 ,p2,0 )
					up(0 ,0 ,p3)
					up(0 ,0 ,0 )					
				}


		
	} 

}

void write() {
	ofstream fout("pokemon.out");
	
	int ret = Inf;
	
	P ^= 1;
	
	for (int p1 = 1; p1 <= n; ++p1)
		for (int p2 = 1; p2 <= n; ++p2) 
			for (int p3 = 1; p3 <= n; ++p3) 
				if (ret > best[P][p1][p2][p3])
					ret = best[P][p1][p2][p3];
						
	fout << ret << "\n";	
	
	fout.close();
}

int main() {
	read();
	solve();
	write();
	
						
	//debug.close();
	
	return 0;
}
