// Mugurel Ionut Andreica
#include <stdio.h>
#include <time.h>

#define NMAX 44

#define SOL 4
#define INPUT_FILE "ppcover.in"
#define OUTPUT_FILE "ppcover.out"

#define min(a, b) ((a) <= (b) ? (a) : (b))
#define max(a, b) ((a) >= (b) ? (a) : (b))

char A[NMAX][NMAX][NMAX];
int i, j, k, x, N, K, T, q1, q2;

int optCover1(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int K)
{
	int result, res;
	int qimin, qimax, qjmin, qjmax, qkmin, qkmax;
	int pimin, pimax, pjmin, pjmax, pkmin, pkmax;

	if (imin > imax || jmin > jmax || kmin > kmax)
		return 0;
	
	if (K == 1)
		return (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	result = (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	for (qimin = imin; qimin <= imax; qimin++)
		for (qimax = qimin; qimax <= imax; qimax++)
			for (qjmin = jmin; qjmin <= jmax; qjmin++)
				for (qjmax = qjmin; qjmax <= jmax; qjmax++)
					for (qkmin = kmin; qkmin <= kmax; qkmin++)
						for (qkmax = qkmin; qkmax <= kmax; qkmax++)
						{
							res = (qimax - qimin + 1) * (qjmax - qjmin + 1) * (qkmax - qkmin + 1);

							pimin = pjmin = pkmin = N + 1;
							pimax = pjmax = pkmax = 0;

							for (i = imin; i <= imax; i++)
								for (j = jmin; j <= jmax; j++)
									for (k = kmin; k <= kmax; k++)
										if (A[i][j][k] == 1 && (i < qimin || i > qimax || j < qjmin || j > qjmax || k < qkmin || k > qkmax))
										{
											pimin = min(pimin, i);
											pimax = max(pimax, i);
											pjmin = min(pjmin, j);
											pjmax = max(pjmax, j);
											pkmin = min(pkmin, k);
											pkmax = max(pkmax, k);
										}

							res += optCover1(pimin, pimax, pjmin, pjmax, pkmin, pkmax, K - 1);

							if (res < result)
								result = res;
						}

	return result;
}

int optCover2(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int K)
{
	int result, res, nsel, lim, b, c, i, j, k, minDim;
	int nextimin, nextimax, nextjmin, nextjmax, nextkmin, nextkmax, qimin, qimax, qjmin, qjmax, qkmin, qkmax, pimin, pimax, pjmin, pjmax, pkmin, pkmax;

	if (imin > imax || jmin > jmax || kmin > kmax)
		return 0;
	
	if (K == 1)
		return (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	result = (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);
	lim = 1 << 6;
	minDim = 6 / K;
	if (6 % K > 0)
		minDim++;

	for (c = 1; c < lim; c++)
	{
		nsel = 0;
		nextimin = nextimax = nextjmin = nextjmax = nextkmin = nextkmax = 0;

		for (b = 0; b < 6; b++)
			if (c & (1 << b))
			{
				if (b == 0)
					nextimin = imin;
				if (b == 1)
					nextimax = imax;
				if (b == 2)
					nextjmin = jmin;
				if (b == 3)
					nextjmax = jmax;
				if (b == 4)
					nextkmin = kmin;
				if (b == 5)
					nextkmax = kmax;

				nsel++;
			}

		if (nsel != minDim)
			continue;

		for (qimin = (nextimin == 0 ? imin : nextimin); qimin <= (nextimin == 0 ? imax: nextimin); qimin++)
			for (qimax = (nextimax == 0 ? qimin : nextimax); qimax <= (nextimax == 0 ? imax: nextimax); qimax++)
				for (qjmin = (nextjmin == 0 ? jmin : nextjmin); qjmin <= (nextjmin == 0 ? jmax: nextjmin); qjmin++)
					for (qjmax = (nextjmax == 0 ? qjmin : nextjmax); qjmax <= (nextjmax == 0 ? jmax: nextjmax); qjmax++)
						for (qkmin = (nextkmin == 0 ? kmin : nextkmin); qkmin <= (nextkmin == 0 ? kmax: nextkmin); qkmin++)
							for (qkmax = (nextkmax == 0 ? qkmin : nextkmax); qkmax <= (nextkmax == 0 ? kmax: nextkmax); qkmax++)
							{
								/*
								if (qimin == 1 && qimax == 3 && qjmin == 1 && qjmax == 3 && qkmin == 1 && qkmax == 2)
								{
									fprintf(stderr, "x\n");
								}
								*/

								res = (qimax - qimin + 1) * (qjmax - qjmin + 1) * (qkmax - qkmin + 1);

								pimin = pjmin = pkmin = N + 1;
								pimax = pjmax = pkmax = 0;

								for (i = imin; i <= imax; i++)
									for (j = jmin; j <= jmax; j++)
										for (k = kmin; k <= kmax; k++)
											if (A[i][j][k] == 1 && (i < qimin || i > qimax || j < qjmin || j > qjmax || k < qkmin || k > qkmax))
											{
												pimin = min(pimin, i);
												pimax = max(pimax, i);
												pjmin = min(pjmin, j);
												pjmax = max(pjmax, j);
												pkmin = min(pkmin, k);
												pkmax = max(pkmax, k);
											}

								res += optCover2(pimin, pimax, pjmin, pjmax, pkmin, pkmax, K - 1);

								if (res < result)
									result = res;
							}
	}

	return result;
}

unsigned char ximin[NMAX][6], ximax[NMAX][6], xjmin[NMAX][6], xjmax[NMAX][6], xkmin[NMAX][6], xkmax[NMAX][6];

void precompute()
{
	int i, j, k;

	// compute for 0
	ximin[0][0] = xjmin[0][0] = xkmin[0][0] = N + 1;
	ximax[0][0] = xjmax[0][0] = xkmax[0][0] = 0;

	for (i = 1; i <= N; i++)
	{
		ximin[i][0] = ximin[i - 1][0];
		ximax[i][0] = ximax[i - 1][0];
		xjmin[i][0] = xjmin[i - 1][0];
		xjmax[i][0] = xjmax[i - 1][0];
		xkmin[i][0] = xkmin[i - 1][0];
		xkmax[i][0] = xkmax[i - 1][0];

		for (j = 1; j <= N; j++)
			for (k = 1; k <= N; k++)
				if (A[i][j][k] == 1)
				{
					ximin[i][0] = min(ximin[i][0], i);
					ximax[i][0] = max(ximax[i][0], i);
					xjmin[i][0] = min(xjmin[i][0], j);
					xjmax[i][0] = max(xjmax[i][0], j);
					xkmin[i][0] = min(xkmin[i][0], k);
					xkmax[i][0] = max(xkmax[i][0], k);
				}
	}

	// compute for 1
	ximin[N + 1][1] = xjmin[N + 1][1] = xkmin[N + 1][1] = N + 1;
	ximax[N + 1][1] = xjmax[N + 1][1] = xkmax[N + 1][1] = 0;

	for (i = N; i >= 1; i--)
	{
		ximin[i][1] = ximin[i + 1][1];
		ximax[i][1] = ximax[i + 1][1];
		xjmin[i][1] = xjmin[i + 1][1];
		xjmax[i][1] = xjmax[i + 1][1];
		xkmin[i][1] = xkmin[i + 1][1];
		xkmax[i][1] = xkmax[i + 1][1];

		for (j = 1; j <= N; j++)
			for (k = 1; k <= N; k++)
				if (A[i][j][k] == 1)
				{
					ximin[i][1] = min(ximin[i][1], i);
					ximax[i][1] = max(ximax[i][1], i);
					xjmin[i][1] = min(xjmin[i][1], j);
					xjmax[i][1] = max(xjmax[i][1], j);
					xkmin[i][1] = min(xkmin[i][1], k);
					xkmax[i][1] = max(xkmax[i][1], k);
				}
	}

	// compute for 2
	ximin[0][2] = xjmin[0][2] = xkmin[0][2] = N + 1;
	ximax[0][2] = xjmax[0][2] = xkmax[0][2] = 0;

	for (j = 1; j <= N; j++)
	{
		ximin[j][2] = ximin[j - 1][2];
		ximax[j][2] = ximax[j - 1][2];
		xjmin[j][2] = xjmin[j - 1][2];
		xjmax[j][2] = xjmax[j - 1][2];
		xkmin[j][2] = xkmin[j - 1][2];
		xkmax[j][2] = xkmax[j - 1][2];

		for (i = 1; i <= N; i++)
			for (k = 1; k <= N; k++)
				if (A[i][j][k] == 1)
				{
					ximin[j][2] = min(ximin[j][2], i);
					ximax[j][2] = max(ximax[j][2], i);
					xjmin[j][2] = min(xjmin[j][2], j);
					xjmax[j][2] = max(xjmax[j][2], j);
					xkmin[j][2] = min(xkmin[j][2], k);
					xkmax[j][2] = max(xkmax[j][2], k);
				}
	}

	// compute for 3
	ximin[N + 1][3] = xjmin[N + 1][3] = xkmin[N + 1][3] = N + 1;
	ximax[N + 1][3] = xjmax[N + 1][3] = xkmax[N + 1][3] = 0;

	for (j = N; j >= 1; j--)
	{
		ximin[j][3] = ximin[j + 1][3];
		ximax[j][3] = ximax[j + 1][3];
		xjmin[j][3] = xjmin[j + 1][3];
		xjmax[j][3] = xjmax[j + 1][3];
		xkmin[j][3] = xkmin[j + 1][3];
		xkmax[j][3] = xkmax[j + 1][3];

		for (i = 1; i <= N; i++)
			for (k = 1; k <= N; k++)
				if (A[i][j][k] == 1)
				{
					ximin[j][3] = min(ximin[j][3], i);
					ximax[j][3] = max(ximax[j][3], i);
					xjmin[j][3] = min(xjmin[j][3], j);
					xjmax[j][3] = max(xjmax[j][3], j);
					xkmin[j][3] = min(xkmin[j][3], k);
					xkmax[j][3] = max(xkmax[j][3], k);
				}
	}

	// compute for 4
	ximin[0][4] = xjmin[0][4] = xkmin[0][4] = N + 1;
	ximax[0][4] = xjmax[0][4] = xkmax[0][4] = 0;

	for (k = 1; k <= N; k++)
	{
		ximin[k][4] = ximin[k - 1][4];
		ximax[k][4] = ximax[k - 1][4];
		xjmin[k][4] = xjmin[k - 1][4];
		xjmax[k][4] = xjmax[k - 1][4];
		xkmin[k][4] = xkmin[k - 1][4];
		xkmax[k][4] = xkmax[k - 1][4];

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				if (A[i][j][k] == 1)
				{
					ximin[k][4] = min(ximin[k][4], i);
					ximax[k][4] = max(ximax[k][4], i);
					xjmin[k][4] = min(xjmin[k][4], j);
					xjmax[k][4] = max(xjmax[k][4], j);
					xkmin[k][4] = min(xkmin[k][4], k);
					xkmax[k][4] = max(xkmax[k][4], k);
				}
	}

	// compute for 5
	ximin[N + 1][5] = xjmin[N + 1][5] = xkmin[N + 1][5] = N + 1;
	ximax[N + 1][5] = xjmax[N + 1][5] = xkmax[N + 1][5] = 0;

	for (k = N; k >= 1; k--)
	{
		ximin[k][5] = ximin[k + 1][5];
		ximax[k][5] = ximax[k + 1][5];
		xjmin[k][5] = xjmin[k + 1][5];
		xjmax[k][5] = xjmax[k + 1][5];
		xkmin[k][5] = xkmin[k + 1][5];
		xkmax[k][5] = xkmax[k + 1][5];

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				if (A[i][j][k] == 1)
				{
					ximin[k][5] = min(ximin[k][5], i);
					ximax[k][5] = max(ximax[k][5], i);
					xjmin[k][5] = min(xjmin[k][5], j);
					xjmax[k][5] = max(xjmax[k][5], j);
					xkmin[k][5] = min(xkmin[k][5], k);
					xkmax[k][5] = max(xkmax[k][5], k);
				}
	}
}

int optCover3(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int K)
{
	int result, res, nsel, lim, b, c, i, j, k, minDim;
	int nextimin, nextimax, nextjmin, nextjmax, nextkmin, nextkmax, qimin, qimax, qjmin, qjmax, qkmin, qkmax, pimin, pimax, pjmin, pjmax, pkmin, pkmax;

	if (imin > imax || jmin > jmax || kmin > kmax)
		return 0;
	
	if (K == 1)
		return (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	if (K == 2)
		precompute();

	for (qimin = imin; qimin <= imax; qimin++)
		for (qimax = qimin; qimax <= imax; qimax++)
			for (qjmin = jmin; qjmin <= jmax; qjmin++)
				for (qjmax = qjmin; qjmax <= jmax; qjmax++)
					for (qkmin = kmin; qkmin <= kmax; qkmin++)
						for (qkmax = qkmin; qkmax <= kmax; qkmax++)
						{
							res = (qimax - qimin + 1) * (qjmax - qjmin + 1) * (qkmax - qkmin + 1);

							pimin = min(ximin[qimin - 1][0], min(ximin[qimax + 1][1], min(ximin[qjmin - 1][2], min(ximin[qjmax + 1][3], min(ximin[qkmin - 1][4], ximin[qkmax + 1][5])))));
							pimax = max(ximax[qimin - 1][0], max(ximax[qimax + 1][1], max(ximax[qjmin - 1][2], max(ximax[qjmax + 1][3], max(ximax[qkmin - 1][4], ximax[qkmax + 1][5])))));
							pjmin = min(xjmin[qimin - 1][0], min(xjmin[qimax + 1][1], min(xjmin[qjmin - 1][2], min(xjmin[qjmax + 1][3], min(xjmin[qkmin - 1][4], xjmin[qkmax + 1][5])))));
							pjmax = max(xjmax[qimin - 1][0], max(xjmax[qimax + 1][1], max(xjmax[qjmin - 1][2], max(xjmax[qjmax + 1][3], max(xjmax[qkmin - 1][4], xjmax[qkmax + 1][5])))));
							pkmin = min(xkmin[qimin - 1][0], min(xkmin[qimax + 1][1], min(xkmin[qjmin - 1][2], min(xkmin[qjmax + 1][3], min(xkmin[qkmin - 1][4], xkmin[qkmax + 1][5])))));
							pkmax = max(xkmax[qimin - 1][0], max(xkmax[qimax + 1][1], max(xkmax[qjmin - 1][2], max(xkmax[qjmax + 1][3], max(xkmax[qkmin - 1][4], xkmax[qkmax + 1][5])))));

							res += optCover3(pimin, pimax, pjmin, pjmax, pkmin, pkmax, K - 1);

							if (res < result)
								result = res;
						}

	return result;
}

int optCover4(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int K)
{
	int result, res, nsel, lim, b, c, i, j, k, minDim, cnt;
	int nextimin, nextimax, nextjmin, nextjmax, nextkmin, nextkmax, qimin, qimax, qjmin, qjmax, qkmin, qkmax, pimin, pimax, pjmin, pjmax, pkmin, pkmax;

	if (imin > imax || jmin > jmax || kmin > kmax)
		return 0;
	
	if (K == 1)
		return (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	if (K == 2)
		precompute();

	result = (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);
	lim = 1 << 6;
	minDim = 6 / K;
	if (6 % K > 0)
		minDim++;

	for (cnt = 0, c = 1; c < lim; c++)
	{
		nsel = 0;
		nextimin = nextimax = nextjmin = nextjmax = nextkmin = nextkmax = 0;

		for (b = 0; b < 6; b++)
			if (c & (1 << b))
			{
				if (b == 0)
					nextimin = imin;
				if (b == 1)
					nextimax = imax;
				if (b == 2)
					nextjmin = jmin;
				if (b == 3)
					nextjmax = jmax;
				if (b == 4)
					nextkmin = kmin;
				if (b == 5)
					nextkmax = kmax;

				nsel++;
			}

		if (nsel != minDim)
			continue;

		cnt++;

		/*
		if ((nextimin > 0 && nextimax > 0) || (nextjmin > 0 && nextjmax > 0) || (nextkmin > 0 && nextkmax > 0))
			continue;
		*/

		for (qimin = (nextimin == 0 ? imin : nextimin); qimin <= (nextimin == 0 ? imax: nextimin); qimin++)
			for (qimax = (nextimax == 0 ? qimin : nextimax); qimax <= (nextimax == 0 ? imax: nextimax); qimax++)
				for (qjmin = (nextjmin == 0 ? jmin : nextjmin); qjmin <= (nextjmin == 0 ? jmax: nextjmin); qjmin++)
					for (qjmax = (nextjmax == 0 ? qjmin : nextjmax); qjmax <= (nextjmax == 0 ? jmax: nextjmax); qjmax++)
						for (qkmin = (nextkmin == 0 ? kmin : nextkmin); qkmin <= (nextkmin == 0 ? kmax: nextkmin); qkmin++)
							for (qkmax = (nextkmax == 0 ? qkmin : nextkmax); qkmax <= (nextkmax == 0 ? kmax: nextkmax); qkmax++)
							{
								res = (qimax - qimin + 1) * (qjmax - qjmin + 1) * (qkmax - qkmin + 1);

								pimin = min(ximin[qimin - 1][0], min(ximin[qimax + 1][1], min(ximin[qjmin - 1][2], min(ximin[qjmax + 1][3], min(ximin[qkmin - 1][4], ximin[qkmax + 1][5])))));
								pimax = max(ximax[qimin - 1][0], max(ximax[qimax + 1][1], max(ximax[qjmin - 1][2], max(ximax[qjmax + 1][3], max(ximax[qkmin - 1][4], ximax[qkmax + 1][5])))));
								pjmin = min(xjmin[qimin - 1][0], min(xjmin[qimax + 1][1], min(xjmin[qjmin - 1][2], min(xjmin[qjmax + 1][3], min(xjmin[qkmin - 1][4], xjmin[qkmax + 1][5])))));
								pjmax = max(xjmax[qimin - 1][0], max(xjmax[qimax + 1][1], max(xjmax[qjmin - 1][2], max(xjmax[qjmax + 1][3], max(xjmax[qkmin - 1][4], xjmax[qkmax + 1][5])))));
								pkmin = min(xkmin[qimin - 1][0], min(xkmin[qimax + 1][1], min(xkmin[qjmin - 1][2], min(xkmin[qjmax + 1][3], min(xkmin[qkmin - 1][4], xkmin[qkmax + 1][5])))));
								pkmax = max(xkmax[qimin - 1][0], max(xkmax[qimax + 1][1], max(xkmax[qjmin - 1][2], max(xkmax[qjmax + 1][3], max(xkmax[qkmin - 1][4], xkmax[qkmax + 1][5])))));

								res += optCover4(pimin, pimax, pjmin, pjmax, pkmin, pkmax, K - 1);

								if (res < result)
									result = res;
							}
	}

	return result;
}

int optCover5(int imin, int imax, int jmin, int jmax, int kmin, int kmax, int K)
{
	int result, res, t, i, vleft, vright;

	result = (imax - imin + 1) * (jmax - jmin + 1) * (kmax - kmin + 1);

	precompute();

	for (t = 0; t < 6; t += 2)
	{
		for (i = 0; i <= N; i++)
		{
			if (ximin[i][t] > ximax[i][t] || xjmin[i][t] > xjmax[i][t] || xkmin[i][t] > xkmax[i][t])
				vleft = 0;
			else
				vleft = (ximax[i][t] - ximin[i][t] + 1) * (xjmax[i][t] - xjmin[i][t] + 1) * (xkmax[i][t] - xkmin[i][t] + 1);

			if (ximin[i + 1][t + 1] > ximax[i + 1][t + 1] || xjmin[i + 1][t + 1] > xjmax[i + 1][t + 1] || xkmin[i + 1][t + 1] > xkmax[i + 1][t + 1])
				vright = 0;
			else
				vright = (ximax[i + 1][t + 1] - ximin[i + 1][t + 1] + 1) * (xjmax[i + 1][t + 1] - xjmin[i + 1][t + 1] + 1) * (xkmax[i + 1][t + 1] - xkmin[i + 1][t + 1] + 1);
		
			if (vleft + vright < result)
				result = vleft + vright;
		}
	}

	return result;
}

#define LINESIZE 1000
char line[LINESIZE];

int main()
{
	int tstart = clock();

	int qK;
	int imin, imax, jmin, jmax, kmin, kmax;

	freopen(INPUT_FILE, "r", stdin);
	freopen(OUTPUT_FILE, "w", stdout);

	fgets(line, LINESIZE - 2, stdin);
	sscanf(line, "%d", &T);

	while (T--)
	{
		fgets(line, LINESIZE - 2, stdin);
		sscanf(line, "%d", &N);

		imin = jmin = kmin = N + 1;
		imax = jmax = kmax = 0;

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
			{
				fgets(&A[i][j][1], NMAX - 2, stdin);
				for (k = 1; k <= N; k++)
				{
					A[i][j][k] -= '0';

					if (A[i][j][k] == 1)
					{
						imin = min(imin, i);
						imax = max(imax, i);
						jmin = min(jmin, j);
						jmax = max(jmax, j);
						kmin = min(kmin, k);
						kmax = max(kmax, k);
					}
				}
			}

		if (SOL == 1)
		{
			q1 = optCover1(imin, imax, jmin, jmax, kmin, kmax, 1);
			q2 = optCover1(imin, imax, jmin, jmax, kmin, kmax, 2);
		}
		else
		if (SOL == 2)
		{
			q1 = optCover2(imin, imax, jmin, jmax, kmin, kmax, 1);
			q2 = optCover2(imin, imax, jmin, jmax, kmin, kmax, 2);
		}
		else
		if (SOL == 3)
		{
			q1 = optCover3(imin, imax, jmin, jmax, kmin, kmax, 1);
			q2 = optCover3(imin, imax, jmin, jmax, kmin, kmax, 2);
		}
		else
		if (SOL == 4)
		{
			q1 = optCover4(imin, imax, jmin, jmax, kmin, kmax, 1);
			q2 = optCover4(imin, imax, jmin, jmax, kmin, kmax, 2);
		}
		if (SOL == 5)
		{
			q1 = optCover1(imin, imax, jmin, jmax, kmin, kmax, 1);
			q2 = optCover5(imin, imax, jmin, jmax, kmin, kmax, 2);
		}

		printf("%d\n", q2);

		fprintf(stderr, "N=%d => %d ; %d\n", N, q1, q2);
	}

	fprintf(stderr, "Duration = %.3lf sec\n", ((double) (clock() - tstart)) / CLOCKS_PER_SEC);

	return 0;
}
