// Cosmin Gheorghe

#include <stdio.h>
#include <algorithm>
using namespace std;

#define NMAX 45

int T, N, rez, xb1, xb2, yb1, yb2, zb1, zb2;

int a[NMAX][NMAX][NMAX];

int xmin[NMAX][7], xmax[NMAX][7];
int ymin[NMAX][7], ymax[NMAX][7];
int zmin[NMAX][7], zmax[NMAX][7];

inline int min(int a, int b)
{
	return (a < b) ? a : b;
}
inline int max(int a, int b)
{
	return (a > b) ? a : b;
}

inline void up_min(int &val, int x)
{
	val = min(val, x);
}
inline void up_max(int &val, int x)
{
	val = max(val, x);
}

void precalc()
{
	int i, j, k, q;

	for (i = 0; i <= N + 1; i++) {
		for (q = 1; q <= 6; q++) {
			xmin[i][q] = ymin[i][q] = zmin[i][q] = N + 1;
			xmax[i][q] = ymax[i][q] = zmax[i][q] = 0;
		}
	}

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			for (k = 1; k <= N; k++) {
				if (!a[i][j][k]) continue;

up_min(xmin[i][1], i); up_max(xmax[i][1], i); up_min(ymin[i][1], j); up_max(ymax[i][1], j); up_min(zmin[i][1], k); up_max(zmax[i][1], k);
up_min(xmin[i][4], i); up_max(xmax[i][4], i); up_min(ymin[i][4], j); up_max(ymax[i][4], j); up_min(zmin[i][4], k); up_max(zmax[i][4], k);

up_min(xmin[j][2], i); up_max(xmax[j][2], i); up_min(ymin[j][2], j); up_max(ymax[j][2], j); up_min(zmin[j][2], k); up_max(zmax[j][2], k);
up_min(xmin[j][5], i); up_max(xmax[j][5], i); up_min(ymin[j][5], j); up_max(ymax[j][5], j); up_min(zmin[j][5], k); up_max(zmax[j][5], k);

up_min(xmin[k][3], i); up_max(xmax[k][3], i); up_min(ymin[k][3], j); up_max(ymax[k][3], j); up_min(zmin[k][3], k); up_max(zmax[k][3], k);
up_min(xmin[k][6], i); up_max(xmax[k][6], i); up_min(ymin[k][6], j); up_max(ymax[k][6], j); up_min(zmin[k][6], k); up_max(zmax[k][6], k);
			}

	// aflu min si max pentru 1 2 3 (adica 1...i)
	
	for (q = 1; q <= 3; q++) {
		xmin[0][q] = ymin[0][q] = zmin[0][q] = N + 1;
		xmax[0][q] = ymax[0][q] = zmax[0][q] = 0;
	}

	for (i = 1; i <= N; i++) {
		for (q = 1; q <= 3; q++) {
			xmin[i][q] = min(xmin[i][q], xmin[i-1][q]);
			ymin[i][q] = min(ymin[i][q], ymin[i-1][q]);
			zmin[i][q] = min(zmin[i][q], zmin[i-1][q]);

			xmax[i][q] = max(xmax[i][q], xmax[i-1][q]);
			ymax[i][q] = max(ymax[i][q], ymax[i-1][q]);
			zmax[i][q] = max(zmax[i][q], zmax[i-1][q]);
		}
	}

	// aflu min si max pentru 4 5 6 (adica i...N)
	
	for (q = 4; q <= 6; q++) {
		xmin[N + 1][q] = ymin[N + 1][q] = zmin[N + 1][q] = N + 1;
		xmax[N + 1][q] = ymax[N + 1][q] = zmax[N + 1][q] = 0;
	}

	for (i = N; i >= 1; i--) {
		for (q = 4; q <= 6; q++) {
			xmin[i][q] = min(xmin[i][q], xmin[i + 1][q]);
			ymin[i][q] = min(ymin[i][q], ymin[i + 1][q]);
			zmin[i][q] = min(zmin[i][q], zmin[i + 1][q]);

			xmax[i][q] = max(xmax[i][q], xmax[i + 1][q]);
			ymax[i][q] = max(ymax[i][q], ymax[i + 1][q]);
			zmax[i][q] = max(zmax[i][q], zmax[i + 1][q]);
		}
	}
}

inline void put(int &x1, int &x2, int &y1, int &y2, int &z1, int &z2, int poz, int q)
{
	x1 = min(x1, xmin[poz][q]);
	x2 = max(x2, xmax[poz][q]);

	y1 = min(y1, ymin[poz][q]);
	y2 = max(y2, ymax[poz][q]);

	z1 = min(z1, zmin[poz][q]);
	z2 = max(z2, zmax[poz][q]);
}

inline int get_arie(int x1, int x2, int y1, int y2, int z1, int z2)
{
	if (x1 > x2 || y1 > y2 || z1 > z2) return 0;

	return (x2 - x1 + 1) * (y2 - y1 + 1) * (z2 - z1 + 1);
}

void baga(int c1[], int c2[])
{
	int x1, x2, y1, y2, z1, z2;
	int xx1 = N + 1, xx2 = 0, yy1 = N + 1, yy2 = 0, zz1 = N + 1, zz2 = 0;

	for (x1 = c1[1]; x1 <= c2[1]; x1++)
		for (y1 = c1[2]; y1 <= c2[2]; y1++)
			for (z1 = c1[3]; z1 <= c2[3]; z1++)
				for (x2 = c1[4]; x2 <= c2[4]; x2++)
					for (y2 = c1[5]; y2 <= c2[5]; y2++)
						for (z2 = c1[6]; z2 <= c2[6]; z2++) {
							xx1 = N + 1, xx2 = 0, yy1 = N + 1, yy2 = 0, zz1 = N + 1, zz2 = 0;

							put(xx1, xx2, yy1, yy2, zz1, zz2, x1 - 1, 1);
							put(xx1, xx2, yy1, yy2, zz1, zz2, y1 - 1, 2);
							put(xx1, xx2, yy1, yy2, zz1, zz2, z1 - 1, 3);
							put(xx1, xx2, yy1, yy2, zz1, zz2, x2 + 1, 4);
							put(xx1, xx2, yy1, yy2, zz1, zz2, y2 + 1, 5);
							put(xx1, xx2, yy1, yy2, zz1, zz2, z2 + 1, 6);

							rez = min(rez, get_arie(x1, x2, y1, y2, z1, z2) + get_arie(xx1, xx2, yy1, yy2, zz1, zz2));
						}
}

inline void set(int cord, int c1[], int c2[], int op)
{
	if (cord == 1 || cord == 4) {
		if (op == 0) c1[cord] = c2[cord] = cord <= 3 ? xb1 : xb2;
		if (op == 1) c1[cord] = xb1, c2[cord] = xb2;
	}

	if (cord == 2 || cord == 5) {
		if (op == 0) c1[cord] = c2[cord] = cord <= 3 ? yb1 : yb2;
		if (op == 1) c1[cord] = yb1, c2[cord] = yb2;
	}

	if (cord == 3 || cord == 6) {
		if (op == 0) c1[cord] = c2[cord] = cord <= 3 ? zb1 : zb2;
		if (op == 1) c1[cord] = zb1, c2[cord] = zb2;
	}
}


int solve()
{
	// hai cu precalculatu
 	precalc();

	xb1 = yb1 = zb1 = 1;
	xb2 = yb2 = zb2 = N;
	for (int i = 1; i <= N; i++) {
		if (!xmax[i][1]) xb1 = i + 1;
		if (!ymax[i][2]) yb1 = i + 1;
		if (!zmax[i][3]) zb1 = i + 1;
	}
	for (int i = N; i >= 1; i--) {
		if (xmin[i][4] == N + 1) xb2 = i - 1;
		if (ymin[i][5] == N + 1) yb2 = i - 1;
		if (zmin[i][6] == N + 1) zb2 = i - 1;
	}

	int c1[10], c2[10];

	int i, j, k;

	for (i = 1; i <= 6; i++) c1[i] = 1, c2[i] = N;

	for (i = 1; i <= 6; i++) {
		set(i, c1, c2, 0);
		for (j = i + 1; j <= 6; j++) {
			set(j, c1, c2, 0);
			for (k = j + 1; k <= 6; k++) {
				set(k, c1, c2, 0);

				baga(c1, c2);

				set(k, c1, c2, 1);
			}
			set(j, c1, c2, 1);
		}
		set(i, c1, c2, 1);
	}

	return 0;

}

int main()
{
	int i, j, k;
	char s[NMAX];

	freopen("ppcover.in", "r", stdin);
	freopen("ppcover.out", "w", stdout);

	for (scanf("%d", &T); T; --T) {
		scanf("%d", &N);

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++) {
				scanf("%s", s);
				for (k = 0; k < N; k++) a[i][j][k + 1] = s[k] - '0';
			}

		rez = NMAX * NMAX * NMAX;
		solve();
		printf("%d\n", rez);
	}


	return 0;
}

