/* Autor: Paul-Dan Baltescu */

#include <fstream>
#include <cstring>

using namespace std;

const int MAXN = 310;

int N, P, Sol;
int inv[MAXN], prep[MAXN];
int C[MAXN][MAXN];
int cmb[MAXN][MAXN], prev[MAXN][MAXN];

int main() {

	ifstream fin("ubergraf.in");
	ofstream fout("ubergraf.out");

	fin >> N >> P;

	for (int i = 1; i <= N; ++i)
		for (int j = 1; j < P; ++j)
			if ((i*j) % P == 1) {
				inv[i] = j;
				break;
			}

	prep[0] = 1;
	for (int i = 1; i <= N; ++i) 
		prep[i] = (prep[i-1] << 1) % P;

	C[1][1] = 1;
	cmb[0][0] = cmb[0][1] = cmb[1][0] = 1;

	for (int i = 2; i <= N; ++i) {

		memcpy(prev, cmb, sizeof(cmb));
		memset(cmb, 0, sizeof(cmb));

		for (int k = 0; k <= i; ++k)
			cmb[0][k] = 1;


		for (int j = 1; j <= i;	++j)
			for (int k = 1; k <= i-j; ++k) {
				int p = (prep[i-j] - prep[i-j-k]) % P;
				if (p < 0) p += P;

				cmb[j][k] = (1LL * prev[j-1][k] * (p-j+1) * inv[j]) % P;
			}

		for (int j = 1; j <= i; ++j)
			for (int k = 1; k <= i-j; ++k) 
				C[i][j] = (C[i][j] + cmb[j][k] * C[i-j][k]) % P;
	}

	for (int i = 1; i <= N; ++i)
		Sol = (Sol + C[N][i]) % P;

	fout << Sol << endl;

	return 0;
}
