/* Autor: Paul-Dan Baltescu */

#include <fstream>

using namespace std;

const int MAXN = 310;

int N, P;
int inv[MAXN], prep[MAXN];
int C[MAXN][MAXN], Sol;

int getCmb(int x, int y, int z) {
	int res = 1;

	for (int i = 1, v = prep[x-y] - prep[x-y-z]; i <= y; ++i, --v) {
		if (v < 0) v += P;
		res = (res * v) % P;
	}

	for (int i = 1; i <= y; ++i)
		res = (res * inv[i]) % P;

	return res;
}

int main() {
	ifstream fin("ubergraf.in");
	ofstream fout("ubergraf.ok");

	fin >> N >> P;

	for (int i = 1; i <= N; ++i)
		for (int j = 1; j < P; ++j)
			if ((i*j) % P == 1)
				inv[i] = j;
				
	prep[0] = 1;
	for (int i = 1; i <= N; ++i)
		prep[i] = (prep[i-1] * 2) % P;

	C[1][1] = 1;

	for (int i = 2; i <= N; ++i)
		for (int j = 1; j <= i; ++j)
			for (int k = 1; k <= i-j; ++k) 
				C[i][j] = (C[i][j] + C[i-j][k] * getCmb(i, j, k)) % P;

	for (int i = 1; i <= N; ++i)
		Sol = (Sol + C[N][i]) % P;

	fout << Sol << endl;

	return 0;
}
